/* 
 * Copyright (c) 2012 Qualcomm Atheros, Inc.. 
 * All Rights Reserved. 
 * Qualcomm Atheros Confidential and Proprietary. 
 */

#ifndef __MUSIC_GPIO_H__
#define __MUSIC_GPIO_H__

#ifdef __cplusplus
extern "C" {
#endif    /* __cplusplus */


#define REG_GPIO_BASE                   0x18080000

#define REG_GPIO_OE                     0
#define REG_GPIO_IN                     0x4

#define GPIO_EXTERN_GPIO0				0x1
#define GPIO_EXTERN_GPIO1				0x2
#define GPIO_EXTERN_GPIO2				0x4
#define GPIO_EXTERN_MASK				0x7

#define vivo_reg_rd(_phys)    (*(volatile unsigned int *)KSEG1ADDR(_phys))
#define vivo_reg_wr_nf(_phys, _val) \
                    ((*(volatile unsigned int *)KSEG1ADDR(_phys)) = (_val))
#define vivo_reg_wr(_phys, _val) do {     \
                    vivo_reg_wr_nf(_phys, _val);  \
                    vivo_reg_rd(_phys);       \
}while(0);

#define gpio_reg_rd(r)      vivo_reg_rd((REG_GPIO_BASE + (r)))
#define gpio_reg_wr(r, v)   vivo_reg_wr((REG_GPIO_BASE + (r)), (v))

void gpio_config_init(void);


#ifdef __cplusplus
}
#endif    /* __cplusplus */

#endif                          /* __MUSIC_GPIO_H__ */
