/* 
 * Copyright (c) 2012 Qualcomm Atheros, Inc.. 
 * All Rights Reserved. 
 * Qualcomm Atheros Confidential and Proprietary. 
 */

#ifndef _WATCHDOG_H
#define _WATCHDOG_H

#ifdef __cplusplus
extern "C" {
#endif    /* __cplusplus */


#define MUSIC_WD_UNLOCK_NUM 'a'
#define MUSIC_WD_LOCK_NUM   'b'
                                    /* any value expect 'A' can
                                       lock watchdog's register
                                     */
#define MUSIC_WD_ACT_MASK  0x3
#define MUSIC_WD_ACT_NONE  0
#define MUSIC_WD_ACT_INT   1
#define MUSIC_WD_ACT_RESET 2

#define MUSIC_DEFAULT_WD_TIMER_SECONDS  30
#define MUSIC_DEFAULT_WD_TIMER_SECONDS_IN_LOADER 10
#define MUSIC_WD_STEP_COUNTER_MASK  0x0000FF00
#define MUSIC_WD_STEP_COUNTER_SHIFT 8

#define MUSIC_WATCHDOG_LOAD_REG  0x18040000
#define MUSIC_WATCHDOG_VALUE_REG 0x18040004
#define MUSIC_WATCHDOG_CTRL_REG  0x18040008
#define MUSIC_WATCHDOG_CLR_REG   0x1804000c
#define MUSIC_WATCHDOG_RIS_REG   0x18040010
#define MUSIC_WATCHDOG_MIS_REG   0x18040014
#define MUSIC_WATCHDOG_LOCK_REG  0x18040018

#define BIT2 4
union music_watchdog_control_reg
{
    unsigned int val;
    struct
    {
        unsigned int RESERVED1:16;
        unsigned int STEP:8;
        unsigned int RESERVED0:5;
        unsigned int CLR_CNT:1;
        unsigned int RESETEN:1;
        unsigned int INTEN:1;
    } content;
};

void watchdog_init(void);
void watchdog_start(void);
void watchdog_stop(void);
void watchdog_periodic(void);
void watchdog_dump(void);

#ifdef __cplusplus
}
#endif    /* __cplusplus */

#endif
