/*
 * Copyright (c) 2012 Qualcomm Atheros, Inc..
 * All Rights Reserved.
 * Qualcomm Atheros Confidential and Proprietary.
 */

 /*
  * Copyright (c) 2005, Swedish Institute of Computer Science.
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
  * 1. Redistributions of source code must retain the above copyright
  *    notice, this list of conditions and the following disclaimer.
  * 2. Redistributions in binary form must reproduce the above copyright
  *    notice, this list of conditions and the following disclaimer in the
  *    documentation and/or other materials provided with the distribution.
  * 3. Neither the name of the Institute nor the names of its contributors
  *    may be used to endorse or promote products derived from this software
  *    without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  * ARE DISCLAIMED.  IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
  * This file is part of the Contiki operating system.
  *
  * Author: Adam Dunkels <adam@sics.se>
  *
  */
#ifndef __CONTIKI_CONF_H__
#define __CONTIKI_CONF_H__

#ifdef __cplusplus
extern "C" {
#endif    /* __cplusplus */



#include "ctype.h"
#include <inttypes.h>

#define WITH_UIP 1

#define CC_CONF_REGISTER_ARGS          1
#define CC_CONF_FUNCTION_POINTER_ARGS  1
#define CC_CONF_FASTCALL
#define CC_CONF_VA_ARGS                1
/*#define CC_CONF_INLINE                 inline*/

#define CCIF
#define CLIF

typedef uint8_t u8_t;
typedef uint16_t u16_t;
typedef uint32_t u32_t;
typedef int32_t s32_t;
typedef unsigned short uip_stats_t;

#define UIP_CONF_UDP                    1
#define UIP_CONF_MAX_CONNECTIONS        4
#define UIP_CONF_MAX_LISTENPORTS        4
#define UIP_CONF_BYTE_ORDER             UIP_BIG_ENDIAN
#define UIP_CONF_TCP                    1
#define UIP_CONF_TCP_SPLIT              1
#define UIP_CONF_IP_FORWARD             0
#define UIP_CONF_LOGGING                0
#define UIP_CONF_UDP_CHECKSUMS          1
#define UIP_CONF_BROADCAST              1
#define UIP_CONF_STATISTICS             1



#define UIP_CONF_IPV6_CHECKS            1
#define UIP_CONF_IPV6_QUEUE_PKT         0   /*no need buffer? */
#define UIP_CONF_IPV6_REASSEMBLY        0
//#define UIP_CONF_NETIF_MAX_ADDRESSES    3  /*It's useless*/
//#define UIP_CONF_ND6_MAX_PREFIXES       3  /*It's useless*/
//#define UIP_CONF_ND6_MAX_NEIGHBORS      4  /*It's useless*/
//#define UIP_CONF_ND6_MAX_DEFROUTERS     2  /*It's useless*/
#define UIP_CONF_ICMP6                  0
#define UIP_CONF_DS6_NBR_NBU     8
#define UIP_CONF_DS6_DEFRT_NBU   1
#define UIP_CONF_DS6_PREFIX_NBU  3
#define UIP_CONF_DS6_ROUTE_NBU   1  /*not support dynamic route, defined to 1 for compile */
#define UIP_CONF_DS6_ADDR_NBU    3
#define UIP_CONF_DS6_MADDR_NBU   0  //VC++ does not allow zero length arrays
#define UIP_CONF_DS6_AADDR_NBU   1  //inside a struct

typedef unsigned long clock_time_t;

#define CLOCK_CONF_SECOND 1000

#define LOG_CONF_ENABLED 1



#ifdef __cplusplus
}
#endif    /* __cplusplus */

#endif                          /* __CONTIKI_CONF_H__ */
